#ifndef Action_h
#define Action_h

// Actions are a very elegant idea stolen from Stanford University's
// GUI toolkit.  For more info, see Action.CPP
class Action
{
  public:
	virtual ~Action();
    virtual void execute() = 0;
};

class GlobalAction: public Action
{
    void (*f_)();
  public:
    GlobalAction( void (*f)() );
    virtual void execute();
};

template<class T>
class CallbackAction: public Action
{
    T* obj_;
	void (T::*f_)();
  public:
    CallbackAction( T* obj, void (T::*f)() );
    virtual void execute();
};

template<class T>
CallbackAction<T>::CallbackAction( T* obj, void (T::*f)() )
  :obj_(obj), f_(f) {}

template<class T>
void CallbackAction<T>::execute()
  { (obj_->*f_)(); }

#endif
