#ifndef SRCOMM3_Con_inout_h
#define SRCOMM3_Con_inout_h

#include <srcomm3/inout.h>

void ConinoutTranslator( standardout& out );

class conout: public standardout
{
  protected:
	static int X1, Y1, X2, Y2;
  public:
	conout();
	conout( int w );
	~conout();

    virtual void CC _put( int len, const char c[] );

	virtual void CC SetAttr( int f, int b );
	void CC SetAttr( unsigned c ) { SetAttr( c & 0x0f, c >> 4 ); }

	conout& Clear();
	conout& ClearEOL();
	static void Cursor();
	static void Cursor( byte start, byte end );
	static void NoCursor();
	static void Region( int x1, int y1, int x2, int y2 );
	static void NoRegion();
	static void GetRegion( int& x1, int& y1, int& x2, int& y2 );
	conout& GotoXY( int x, int y );
	static void ScrollUp( int lines );
	static void ScrollDown( int lines );
	int WhereX();
	int WhereY();
	int GetAttr();

	static void BIOSVideo();
	static void DirectVideo();
    static void SetVideoBorder( int c );
};

extern conout sout;

class conin: public standardin
{
  private:
	conout& wout;
    int extendedkey;
  public:
	conin( conout& wout = sout );
	~conin();

	virtual void CC begininput();
	virtual void CC endinput();

	virtual int CC keyhit();
	virtual char CC get();
	virtual char CC out( char c );

    unsigned GetKey();
};

extern conin sin;
struct text_info;

class SaveScreen
{
	char* buf;
    text_info* t;
  protected:
	void save();
	void restore();
  public:
	SaveScreen( int pr = 0 );
	~SaveScreen();
};

#endif

