#include <dir.h>
#include <dos.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "Director.h"

static int filter = FA_ARCH;

FileName::FileName( string drv, string dir, string nm, string ext )
{
	char path[512];
	_makepath( path, drv.c_str(), dir.c_str(), nm.c_str(), ext.c_str() );
	name = string(path);
}

string FileName::Path()
{
	char drive[5], dir[256];
	_splitpath( name.c_str(), drive, dir, NULL, NULL );
	return string(drive) + string(dir);
}

string FileName::Drv()
{
	char drv[5];
	_splitpath( name.c_str(), drv, NULL, NULL, NULL );
	return string(drv);
}

string FileName::Dir()
{
	char dir[256];
	_splitpath( name.c_str(), NULL, dir, NULL, NULL );
	return string(dir);
}

string FileName::Ext()
{
	char ext[8];
	_splitpath( name.c_str(), NULL, NULL, NULL, ext );
	return string(ext);
}

string FileName::Name()
{
	char nm[256];
	_splitpath( name.c_str(), NULL, NULL, nm, NULL );
	return string(nm);
}

string FileName::FullName()
{
	return name;
}

Directory::Directory( string m ): mask(m)
{
	valid = 0;
	data = new ffblk;
}

Directory::~Directory()
{
	delete data;
}

void Directory::Reset()
{
	if( valid )
		valid = 0;
}

string Directory::operator () ()
{
	if( !valid )
		valid = !findfirst( mask.c_str(), data, filter );
	else
		valid = !findnext( data );
	if( valid )
	{
		FileName f( mask );
		FileName n( f.Path()+string( data->ff_name ) );
		return n.FullName();
	}
	return "";
}

