// This is mostly copied from SRE... it probably doesn't make much sense :(
// These routines set up a status bar and some function keys (F1 = help,
// F5 = return to BBS, F7 = subtract time, F8 = add time, Alt-J = OS shell)

#include <stdlib.h>
#include <string.h>

#include <cstring.h>
#include <srcomm3/types.h>
#include <srcomm3/srinout.h>
#include <srcomm3/coninout.h>

#include <dos.h>
#include <dir.h>
#include <errno.h>

#include <srcomm3/Door.h>
#include <srcomm3/News.h>
#include <srcomm3/srparam.h>
#include <srcomm3/ansi.h>
#include <srcomm3/fossil.h>
#include <unit/mtask.h>
#include <time.h>

#include <srcomm3/srtime.h>
#include <srcomm3/doorgame.h>
#include <srcomm3/statusba.h>

Resource rGameName( "Game.Name", "" );

int StatusBar::min_y = 1;
int StatusBar::max_y = 25;

StatusBar::StatusBar()
{
	active = false;
	size = 3;
	color = 1;
	status = 0;

	Resource rBackground( "StatusBar.Background", color );
    color = rBackground.Int();
}

StatusBar::~StatusBar()
{
}

void StatusBar::Display( string user, const char *username, char c )
{
    if( !active )
		return;

    min_y = 2;

	byte x = sout.WhereX(), y = sout.WhereY();
	int x1, y1, x2, y2;
	sout.GetRegion( x1, y1, x2, y2 );
	sout.Region( 1, 1, 80, 1 );
	int oldcol = sout.GetAttr();

	sout.Clear();
    sout << attr(color+8,color) << " ";
    sout << attr(15,-1) << DoorGame::name << " " << DoorGame::version;
	if( length( rGameName ) > 0 )
        sout << ' ' << string(rGameName);
    sout << attr(color+8,-1) << "  ";

    if( !DOOR.exists() )
        sout << attr(7,-1) << "Unknown ";
    else if( DOOR.ComPort() == 0 )
        sout << attr(7,-1) << "LOCAL ";
	else
	{
		sout << attr(7,-1) << "COM" << DOOR.ComPort() << ": " << DOOR.RealBaudRate();
        if( DOOR.RealBaudRate() != DOOR.BaudRate() )
            sout << "/Lock=" << DOOR.BaudRate();
		if( Fossil::exists )
            sout << " (fossil)";
	}
	sout.ClearEOL();

    sout.Region( 1, max_y+1, 80, max_y+1 );
	sout.Clear();
	sout << attr(7,-1) << ' ' << user << ' ';
	sout << attr(0,-1) << '';
	sout << attr(14,-1) << c;
	sout << attr(0,-1) << '';
	sout << attr(15,-1) << ' ';
    for( int i = 0; sout.WhereX() < 66 && username[i]; i++ )
		sout << username[i];
	if( sout.WhereX() < 57 )
	{
        int C = 11;
        if( color >= 4 ) C = 14;
		sout << attr(0,-1) << " ";
        sout << attr(C,-1) << "F1 = Help";
	}
	sout.ClearEOL();

	sout.Region( x1, y1, x2, y2 );
	sout.SetAttr( oldcol );
	sout.GotoXY( x, y );

    DisplayTime( Time() );
}

void StatusBar::WindowDisplay()
{
    if( status == 0 || !active )
		return;

	int oldcol = sout.GetAttr();
	int oldx = sout.WhereX(), oldy = sout.WhereY();
    sout.Region( 1, max_y-size+1, 80, max_y );

	sout.GotoXY( 1, 1 );

    if( status == 1 )
	{
		sout << attr(15,color) << "  Help";
		sout.ClearEOL();
		sout << '\n' << attr(7,0) << "Alt-J = Shell, F1 = Help";
		if( GameOutput::ComPort > 0 ) sout << ", F5 = Return to BBS";
		sout.ClearEOL();
		sout << '\n';
		if( DOOR.TimeLimit() >= 0 ) sout << "F7 = Subtract Time, F8 = Add Time";
		if( GameOutput::ComPort > 0 ) sout << ", F10 = Chat";
		sout.ClearEOL();
	}

    if( status == 3 )
	{
		sout << attr(15,color) << "  Message"
			 << attr(0,color) << "  [Recorded in SYSOP.LOG]";
		sout.ClearEOL();
		sout << attr(14,0);
		sout.GotoXY( 1, 3 );
		sout.ClearEOL();
		sout.GotoXY( 1, 2 );
		sout << ErrorLog.LastMessage();
		sout.ClearEOL();
	}

    sout.Region( 1, min_y, 80, max_y-size );
	sout.GotoXY( oldx, oldy );
	sout.SetAttr( oldcol );
}

long StatusBar::TimeLeft()
{
	if( DOOR.TimeLimit() >= 1000 || DOOR.TimeLimit() < 0 ) return 999;
	return DOOR.TimeLimit() - ( Time() - DoorGame::startPlayTime ) / 60L;
}

int DoorInfo::TimeOut()
{
	return ( timelimit < 1000 && Time() - DoorGame::startPlayTime > 60L * timelimit
		  && timelimit > -1 );
}

void StatusBar::DisplayTime( Time TimeNow )
{
    if( !active ) return;

	char s[40];
	strcpy( s, DateDisplay( TimeNow ) );

	int oldcol = sout.GetAttr();
	int oldx = sout.WhereX(), oldy = sout.WhereY();
	sout.Region( 1, 1, 80, 1 );

	sout.GotoXY( 79 - strlen(s), 1 );
    sout << attr(color+8,color) << s;
	sout.ClearEOL();

    sout.Region( 1, max_y+1, 80, max_y+1 );
	sout.GotoXY( 74, 1 );
	if( DOOR.TimeLimit() >= 0 && DOOR.TimeLimit() < 1000 )
        sout << attr(color+8,color) << "TL=" << TimeLeft();
	sout.ClearEOL();

    sout.Region( 1, min_y, 80, max_y-(status?size:0) );
	sout.SetAttr( oldcol );
	sout.GotoXY( oldx, oldy );

	WindowDisplay();
}

void StatusBar::ForceDisplayTime()
{
    DisplayTime( Time() );
}

void DisplayTimeHook()
{
    Time TimeNow;
	static Time LastTime = 0;

	if( TimeNow.Clock()/10 == LastTime.Clock()/10 )
		return;

	LastTime = TimeNow;
	DoorGame::statusBar -> DisplayTime( TimeNow );
}

void StatusBar::SetupWindow( int NewStatus )
{
    if( !active ) return;

    if( !!status == !!NewStatus )
	{
        status = NewStatus;
		return;
	}

    if( !status )
	{
        if( sout.WhereY() > (max_y-min_y-size) )
			sout.ScrollUp( size+1 );
		int x = sout.WhereX(), y = sout.WhereY();
        sout.Region( 1, min_y, 80, max_y-size );
		sout.GotoXY( x, y );
	}
	else
	{
		int x = sout.WhereX();
		int y = sout.WhereY();
        sout.Region( 1, min_y, 80, max_y );
		for( int i = 0; i < size; i++ )
		{
            sout.GotoXY( 1, max_y-min_y-i+1 );
			sout.ClearEOL();
		}
		sout.GotoXY( x, y );
	}

    status = NewStatus;
}

void DisplayHelpHook()
{
	StatusBar* sb = DoorGame::statusBar;
	sb -> SetupWindow( ( sb->HelpStatus() != 1 )? 1 : 0 );
	sb -> WindowDisplay();
}

void DisplayMessagesHook()
{
	DoorGame::statusBar -> SetupWindow( 3 );
	DoorGame::statusBar -> WindowDisplay();
}

void SubTimeHook()
{
	DOOR.SubTime( 5 );
	DoorGame::statusBar -> ForceDisplayTime();
}

void AddTimeHook()
{
	DOOR.AddTime( 5 );
	DoorGame::statusBar -> ForceDisplayTime();
}

void ShellToDos()
{
	// Save the old drive and directory
	char curdrive[256];
	int savedrive = getdisk();
	getcwd( curdrive, 256 );

	int status;
	{
		SaveScreen S;
		status = system( "" );
	}

	// Restore the directory & drive
	chdir( curdrive );
	setdisk( savedrive );

	if( status )
	{
		kout << attr(14,-1) << "\nfailed:  " << attr(7,-1);
		if( errno == ENOMEM )
			kout << "out of memory";
		else if( errno == ENOENT )
			kout << "no such file or directory";
		else
			kout << "internal SWI error SHELL@" << errno
				 << " - report to the Solar Realm";
		kout << ".\n";
	}
}

void HangupHook()
{
	void break_key();
	break_key();
}

// Install
//   F1 as the help window display
//   F5 to hang up
//   F7 as sub time
//   F8 as add time

void InstallKeyHooks()
{
	GameKeyIntercept* F1 = new GameKeyIntercept( DisplayHelpHook, 0, 59 );
	GameKeyIntercept* F5 = new GameKeyIntercept( HangupHook, 0, 63 );
	GameKeyIntercept* F7 = new GameKeyIntercept( SubTimeHook, 0, 65 );
	GameKeyIntercept* F8 = new GameKeyIntercept( AddTimeHook, 0, 66 );
	GameKeyIntercept* AltH = new GameKeyIntercept( HangupHook, 0, 35 );
	GameKeyIntercept* AltJ = new GameKeyIntercept( ShellToDos, 0, 36 );
	GameKeyIntercept* AltF4 = new GameKeyIntercept( ShellToDos, 0, 107 );
	if( !F1 || !F5 || !F7 || !F8 || !AltJ || !AltF4 || !AltH )
		local << "Warning:  out of memory.  "
			  << "Could not install function keys as hotkeys.\n";

	if( F1 ) F1 -> Safe();
	if( F5 ) F5 -> Safe();
	if( F7 ) F7 -> Safe();
	if( F8 ) F8 -> Safe();
	if( AltH ) AltH -> Safe();
}

// Tasks for the multitasker

void UpdateStatusTask()
{
	for(;;)
	{
		sout.Region( 1, StatusBar::min_y, 80, StatusBar::max_y );
		DoorGame::statusBar -> WindowDisplay();
		wait( 1300L );
	}
}

void DisplayTimeTask()
{
	for( ;; )
	{
		DisplayTimeHook();
		wait( 60000L );
	}
}
